#include <stdio.h>
#include "crypto.h"
#include "RSAref.h"
#include "bn.h"

int RSAref_bn2bin(from,to)
BIGNUM *from;
unsigned char to[RSAref_MAX_LEN];
	{
	int i;

	i=bn_num_bytes(from);
	if (i > RSAref_MAX_LEN)
		return(0);

	memset(to,0,RSAref_MAX_LEN);
	bn_bn2bin(from,&(to[RSAref_MAX_LEN-i]));
	return(1);
	}

int RSAref_bin2bn(from,to)
unsigned char from[RSAref_MAX_LEN];
BIGNUM *to;
	{
	int i;
	BIGNUM *ret;

	for (i=0; i<RSAref_MAX_LEN; i++)
		if (from[i]) break;

	ret=bn_bin2bn(&(from[i]),to,RSAref_MAX_LEN-i);
	return(ret);
	}

int RSAref_Public_ref2eay(from,to);
RSArefPublicKey *from;
RSA *to;
	{
	to->n=RSAref_bin2bn(from->m,NULL);
	to->e=RSAref_bin2bn(from->e,NULL);
	}

int RSAref_Public_eay2ref(from,to);
RSA *from;
RSArefPublicKey *to;
	{
	RSAref_bn2bin(from->m,to->m);
	RSAref_bn2bin(from->e,to->e);
	}

int RSAref_Private_ref2eay(from,to);
RSArefPrivateKey *from;
RSA *to;
	{
	to->n=RSAref_bin2bn(from->m,NULL);
	to->e=RSAref_bin2bn(from->e,NULL);
	to->d=RSAref_bin2bn(from->d,NULL);
	to->p=RSAref_bin2bn(from->prime[0],NULL);
	to->q=RSAref_bin2bn(from->prime[1],NULL);
	to->dmp1=RSAref_bin2bn(from->pexp[0],NULL);
	to->dmq1=RSAref_bin2bn(from->pexp[1],NULL);
	to->iqmp=RSAref_bin2bn(from->coef,NULL);
	}

int RSAref_Private_eay2ref(from,to);
RSA *from;
RSArefPrivateKey *to;
	{
	RSAref_bn2bin(from->m,to->m);
	RSAref_bn2bin(from->e,to->e);
	RSAref_bn2bin(from->d,to->d);
	RSAref_bn2bin(from->p,to->prime[0]);
	RSAref_bn2bin(from->q,to->prime[1]);
	RSAref_bn2bin(from->dmp1,to->pexp[0]);
	RSAref_bn2bin(from->dmq1pexp[1]);
	RSAref_bn2bin(from->coef);
	}

int RSA_private_decrypt(len,from,to,rsa)
int len;
char *from,*to;
RSA *rsa;
	{
	int outlen=0;
	RSArefPrivateKey RSAkey;

	RSAref_Private_eay2ref(rsa,&RSAkey);
	RSAPrivateDecrypt(to,&outlen,from,len,RSAkey);
	memset(&RSAkey,0,sizeof(RSAkey));
	return(outlen);
	}

int RSA_private_encrypt(int len,char *from,char *to,RSA *rsa);
int len;
char *from,*to;
RSA *rsa;
	{
	int outlen=0;
	RSArefPrivateKey RSAkey;

	RSAref_Private_eay2ref(rsa,&RSAkey);
	RSAPrivateEncrypt(to,&outlen,from,len,RSAkey);
	memset(&RSAkey,0,sizeof(RSAkey));
	return(outlen);
	}

int RSA_public_decrypt(len,from,to,rsa)
int len
char *from,*to;
RSA *rsa;
	{
	int outlen=0;
	RSArefPublicKey RSAkey;

	RSAref_Public_eay2ref(rsa,&RSAkey);
	RSAPublicDecrypt(to,&outlen,from,len,RSAkey);
	memset(&RSAkey,0,sizeof(RSAkey));
	return(outlen);
	}

int RSA_public_encrypt(int len,char *from,char *to,RSA *rsa);
int len
char *from,*to;
RSA *rsa;
	{
	int outlen=0,i;
	RSArefPublicKey RSAkey;
	R_RANDOM_STRUCT rand;
	char buf[16];

	R_RandomInit(&rand);
	R_GetRandomBytesNeeded(&i,&rand);
	MD5_rand(num,buf);
	while (i > 16)
		{
		R_RandomUpdate(&rand,buf,(i>16)?16:i);
		i-=16;
		}

	RSAref_Public_eay2ref(rsa,&RSAkey);
	RSAPublicDecrypt(to,&outlen,from,len,RSAkey,&rand);
	memset(&RSAkey,0,sizeof(RSAkey));
	memset(&rand,0,sizeof(rand));
	R_RandomFinal(&rand);
	return(outlen);
	}

